/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: AsFixUtilities.java,v 1.10 2000/04/15 15:18:43 mdejonge Exp $
*/
package nl.cwi.gipe.stred;
import toolbus.aterm.*;

public class AsFixUtilities {
  public static ATerm named(String str, ATerms ts) {
    //    if (t.getType() == ATerm.ATERMS) {
    //ATerms ts = (ATerms) t;
    if (ts.isEmpty() == false) {
      if (ts.getFirst().getType() == ATerm.APPL) {
	ATermAppl ta = (ATermAppl) ts.getFirst();
	if (str.equals(ta.getFun())) {
	  return ta;
	}
      }
      return named(str,ts.getNext());
    }
    return ts;
    /*} else if (t.getType() == ATerm.APPL) {
      ATermAppl app = (ATermAppl) t;
      if (str.equals(app.getFun())) {
	return app;
      }
    }
    // A ATerm type we cannot handle has occurred:
    throw new SEException("AsFixUtilities.named cannot handle term: "+ t.toString());
    */
  }
	
  public static ATerms replace(ATermAppl at, ATerms ts) {
    if (ts.isEmpty() == false) {
      if (ts.getFirst().getType() == ATerm.APPL) {
	ATermAppl ta = (ATermAppl) ts.getFirst();
	if (at.getFun().equals(ta.getFun())) {
	  return new ATerms(ATerm.the_world, at, ts.getNext());
	}
      }
      return new ATerms(ATerm.the_world, ts.getFirst(),replace(at, ts.getNext()));
    }
    return ts;
  }
  
  public static Sort typeOf(ATerm t) {
    // Only implemented for lists and appls
    // No checks here... 
    //System.err.println("AsFixUtilities.typeOf: t: "+t.toString());
    ATermAppl ta = (ATermAppl) t;
    String fun = ta.getFun();
    AFun sym = new AFun(ATerm.the_world,"sym");
    AFun term = new AFun(ATerm.the_world,"term");
    if (fun.equals("appl")) {
      ATermAppl prod = (ATermAppl) named("prod", ta.getArgs());
      return new Sort((ATermAppl) AsFix.acc(prod, sym));
    } else if (fun.equals("list")) {
      // it is a list
      return new Sort((ATermAppl) AsFix.acc(ta,sym));
    } else if (fun.equals("lex")) {
			// it is a lexical
			return new Sort((ATermAppl) AsFix.acc(ta,sym));
    } else if (fun.equals("term")) {
			return (typeOf(AsFix.acc(ta,term)));
    } else if (fun.equals("sort")) {
			return new Sort((ATermAppl) AsFix.acc(ta,sym));
		} else if (fun.equals("var")) {
			return new Sort((ATermAppl) AsFix.acc(ta,sym));
		} else {
			//default rule
			return new Sort("invalid");
    }
  }
}
