/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: Editor.java,v 1.8 2000/04/15 15:18:43 mdejonge Exp $
*/
package nl.cwi.gipe.stred;
// $Id: Editor.java,v 1.8 2000/04/15 15:18:43 mdejonge Exp $

import toolbus.aterm.*;

public class Editor {
  private ATerm tree;
  private FocusList focuses;

  public Editor(ATerm term, FocusList fl){
    tree = term;
    focuses = fl;
  }

  // Access functions
  public ATerm tree() {
    return tree;
  }
  
  public FocusList focuses() {
    return focuses;
  }
 
  public Editor setFocuses(FocusList fl) {
    return new Editor(this.tree,fl);
  }

  public Editor setTree(ATerm t) {
    return new Editor(t, this.focuses);
  }

  public FocusList currentFocus(int i)  {
      SeTool.debug("In Editor.currentFocus, arg is i: "+Integer.toString(i));
    FocusList fl = this.focuses;
SeTool.debug("editor.currentFocus, fl: "+fl.toString());
    //   ATerms fs = fl.getATerms();
    if (fl.empty()) {
	//SeTool.debug("Editor.currentFocus: fl is empty");
      Focus f = Focuses.createFocus(this.tree, i);
      return new FocusList(f);
    } else {
      Focus first = fl.head();
      //SeTool.debug("Editor.currentFocus: got head of focus list");
      if (first.in(i)) {
	return fl;
      } else {
	ATerm t = this.tree;
	fl.tail();
	Editor tmpedit = new Editor(t,fl);
	FocusList done = tmpedit.currentFocus(i);
	//	done.tail();
	done.concat(first);
SeTool.debug("done: "+done.toString());
	return Focuses.removeChildren(done.head(), done);
      }
    }
  }
    public String toString() {
	return "tree: "+this.tree.toString()+"\nfocuses: "+this.focuses.toString();
    }
}
