/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: FocusList.java,v 1.8 2000/04/15 15:18:43 mdejonge Exp $
*/
package nl.cwi.gipe.stred;
import toolbus.aterm.*;
import java.util.Vector;

public class FocusList extends Vector {
  public FocusList() {
    super();
  }
  public FocusList(Focus f){
    this();
    addElement(f);
  }
    /*  public FocusList(Focus f, FocusList fl) {
     *    super(the_world,new ATerms(the_world,f, fl.getATerms()));
     *  }
     */

    /** Parse a FocusList represented as an ATermList
     */
    public FocusList(ATermList t) {
	this();

	ATerms ts;
	ATermAppl hd;

	if (t != null) {
	    ts = t.getATerms();
	    while (! ts.isEmpty()) {
		hd = (ATermAppl) ts.getFirst();
		addElement(new Focus(hd));
		ts = ts.getNext();
	    }
	}
    }

    /** Insert a new Focus at the head of the FocusList
     */
    public void insertHead(Focus f){
	insertElementAt(f,0);
    }

  // Access Functions
    public Focus head() {
	return (Focus) firstElement();
    }

    public void tail() {
	removeElementAt(0);
    }

    public boolean empty() {
	return (size() == 0);
    }
  
    public void concat(Focus f) {
	addElement(f);
    }

    /** Convert the FocusList to an ATerm */
    public ATermList toATerm() {
	Focus f;
	ATerms ts = new ATerms();
	for (int i = size()-1 ; i >= 0; i--) {
	    f = (Focus) elementAt(i);
	    ts = new ATerms(f.toATerm(), ts);
	}
	return new ATermList(ts);
    }

    /** Convert the FocusList to a String 
    public String toString() {
	StringBuffer result;
	Focus f;
	int i;

	result = new StringBuffer("[");
	for (i=0; i < size(); i++) {
	    f = (Focus) elementAt(i);
	    result.append(f.toString());
	}
	result.append("]");
	retutn result;
    }
    */
}
