/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: Focuses.java,v 1.10 2000/04/15 15:18:44 mdejonge Exp $
*/
package nl.cwi.gipe.stred;
// $Id: Focuses.java,v 1.10 2000/04/15 15:18:44 mdejonge Exp $
import toolbus.aterm.*;

public class Focuses {
  // list operations on focuses are list operations on ATerms

  // Not quite clear what this is a subclass of. For now only class methods

  public static FocusList removeChildren(Focus f, FocusList fl) {
      //      SeTool.debug("Focuses.removeChildren: f: "+f.toString()+", fl: "+fl.toString());
    if (fl.empty()) {
      return new FocusList(f);
    } else {
      Focus f1 = fl.head();
      fl.tail();
      if (isChild(f1,f)) {
	return removeChildren(f,fl);
      } else {
	  FocusList result = removeChildren(f,fl);
	  result.concat(f1);
	return result;
      }
    }
  }

  public static boolean isChild(Focus f1, Focus f2) {
      //      SeTool.debug("Focuses.isChild: f1: "+f1.toString()+", f2: "+f2.toString());
    return f1.getPath().isChildPath(f2.getPath());
  }

  public static Focus createFocus(ATerm t, int i) {
		ATerm subtree = null;
    SeTool.debug("Focuses.createFocus: Args are t: "+t.toString()+", i: "+Integer.toString(i));
    Path p = PathConstruction.getPath(t,i);
    SeTool.debug("Focuses.createFocus: got path p: "+p.toString());
    Sort s = null;
    try {
			subtree = Subtree.subtree(t,p);
	  	s = AsFixUtilities.typeOf(subtree);
    }
    catch (SubtreeException e) {
			System.err.println(e);
			System.exit(2);
    }
		SeTool.debug("Focuses.createFocus: subtree is "+subtree.toString());
    SeTool.debug("Focuses.createFocus: got type of focus: "+s.toString());
    Area a = Area.createArea(p,t);
    SeTool.debug("Focuses.createFocus: Got area of focus");
    return new Focus(p,s,a);
  }
  
    public static Focus createFocus(ATerm t, Path p) {
    Area a = Area.createArea(p,t);
    Sort s = null;
    try {
	s = AsFixUtilities.typeOf(Subtree.subtree(t,p));
    }
    catch (SubtreeException e) {
	System.err.println(e);
	System.exit(2);
    }
    return new Focus(p,s,a);
  }
}
