/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: Length.java,v 1.5 2000/04/15 15:18:44 mdejonge Exp $
*/
package nl.cwi.gipe.stred;
import toolbus.aterm.*;

public class Length extends ATermAppl {
  public static final String sym = "length";
  public Length(int i) {
    super(the_world,sym,new ATerms(the_world,new ATermInt(the_world,i)));
  }
  //cast constructor
  public Length(ATermAppl t)  {
    super(the_world,sym,t.getArgs());
    if (sym.equals(t.getFun())==false) {
	System.err.println("Tried to make a Length out of some other ATerm, in Length.<init>");
	System.exit(2);
    }
  }

  public int getInt() {
    ATermInt ti = (ATermInt) this.getArgs().getFirst();
    return ti.getInt();
  }

  public void setInt(int i) {
    this.setArgs(new ATerms(the_world,new ATermInt(the_world,i)));
  }
}
